function submitFilter(filterId, modeVal) {
    var filter = document.getElementsByName("filter_id");
    filter[0].value = filterId;
    setMode(modeVal);
    document.getElementsByTagName('form')[0].submit();
}

function submitLdap(ldapId, modeVal) {
    var ldap = document.getElementsByName("ldap_id");
    ldap[0].value = ldapId;
    setMode(modeVal);
    document.getElementsByTagName('form')[0].submit();
}

function submitMail(mailId, modeVal) {
    var mail = document.getElementsByName("mail_id");
    mail[0].value = mailId;
    setMode(modeVal);
    document.getElementsByTagName('form')[0].submit();
}

function submitUser(userId, modeVal) {
    var user = document.getElementsByName("user_id");
    user[0].value = userId;
    setMode(modeVal);
    document.getElementsByTagName('form')[0].submit();
}

function isIe() {
    var ie = (navigator.appName == "Microsoft Internet Explorer");
    return ie;
}

var xsl = null;
var xml = null;
var _displayXmlName;
var sortorder = null;
var sortby = null;
var error = "";

function loadXMLDoc(dname)
{
    error = "";
    var xhttp = null;
    if(isIe()) {
        xhttp = new ActiveXObject("MSXML2.XMLHTTP.6.0");
    }
    else {
        xhttp=new XMLHttpRequest();
    }
    xhttp.open("GET",dname,false);
    xhttp.send("");
    if(xhttp.status != "200") {
        error = "<div style=\"color:red\">" + xhttp.status + ": " + xhttp.statusText + ". Please take a look at the innovaphone Reporting log file.</div>";
        return null;
    }
    else {
        if(xhttp.responseXML == null) {
            if(dname.indexOf("report.fcgi") > 0) {
                error = "<div style=\"color:red\">Invalid XML. View it <a href=\"debug.php?url="+encodeURIComponent(dname)+"\">here.</a></div>";
            }
            else {
                error = "<div style=\"color:red\">Invalid XML: " + xhttp.responseText + "</div>";
            }
        }
        if(isIe()) {
            xhttp.responseXML.setProperty('AllowXsltScript', true);
        }
        return xhttp.responseXML;
    }
}

/*function loadXMLString(value) {
    var xml = null;
    if (window.DOMParser)
    {
        var parser = new DOMParser();
        xml = parser.parseFromString(value, "text/xml");
    }
    else // Internet Explorer
    {
        xml = new ActiveXObject("Microsoft.XMLDOM");
        xml.async = "false";
        xml.loadXML(value);
    }
    return xml;
}*/

function isDefined( variable)
{
    return (typeof(window[variable]) == "undefined")?  false: true;
}

function sortXML(sortName) {
    parseXML('', _displayXmlName, sortName);
}

function parseXML(ajaxHrefName, displayXmlName, sortName) {
    _displayXmlName = displayXmlName;
    var displayXml = document.getElementById(displayXmlName);
    /*var zeit1;
    var zeit2;
    var zeit3;
    var zeit4;*/
    if(xml == null) {
        var ajaxHref = document.getElementsByName(ajaxHrefName);
        if(ajaxHrefName != "" && ajaxHref[0].value != "") {
            //zeit1 = new Date();
            xml = loadXMLDoc(ajaxHref[0].value + "&java=1");
            if(xml == null) {
                displayXml.innerHTML = error;
                return;
            }
            //zeit2 = new Date();
        }
    }
    if(xml != null) {
        if(sortName != "") {
            var report = xml.getElementsByTagName("report")[0];
            report.setAttribute("sort-by", sortName);
            
            if(sortby == sortName) {
                if(sortorder == "ascending") {
                    sortorder = "descending";
                }
                else {
                    sortorder = "ascending";
                }
            }
            else {
                if(sortby == "" && sortName == "time") {
                    sortorder = "descending";
                }
                else {
                    sortorder = "ascending";
                }
                sortby = sortName;
            }
            report.setAttribute("sort-order", sortorder);
        }
        else {
            sortby = "";
        }
        if(xsl == null) {
            xsl = loadXMLDoc("report.xsl");
            if(xsl == null) {
                displayXml.innerHTML = error;
                return;
            }
        }
        //zeit3 = new Date();
        // code for IE
        if (window.ActiveXObject) {
            ex=xml.transformNode(xsl);
            displayXml.innerHTML=ex;
        }
        // code for Mozilla, Firefox, Opera, etc.
        else if (document.implementation && document.implementation.createDocument) {
            xsltProcessor=new XSLTProcessor();
            xsltProcessor.importStylesheet(xsl);
            resultDocument = xsltProcessor.transformToFragment(xml,document);
            while(displayXml.childNodes.length > 0) {
                displayXml.removeChild(displayXml.firstChild);
            }
            displayXml.appendChild(resultDocument);
        }
        /*zeit4 = new Date();
        var t1 = zeit4.getTime() - zeit3.getTime();
        var t2 = zeit2.getTime() - zeit1.getTime();
        alert ("XSL-Transform: " + t1 + "\r\nReport: " + t2);*/
    }
}

function checkPbxObject(pbxObj, btnName) {
    var btn = document.getElementsByName(btnName);
    if(pbxObj.value == "") {
        btn[0].disabled = true;
    }
    else {
        btn[0].disabled = false;
    }
}

function changeReplicationMode(off, modeName, serverName, pwName, intervalName) {
    var mode = document.getElementsByName(modeName + "[]")[0];
    var server = document.getElementsByName(serverName)[0];
    var pw = document.getElementsByName(pwName)[0];
    var interval = document.getElementsByName(intervalName)[0];
    if (mode.options[mode.selectedIndex].value == off) {
        server.parentNode.parentNode.style.display = "none";
        pw.parentNode.parentNode.style.display = "none";
        interval.parentNode.parentNode.style.display = "none";
    }
    else {
        server.parentNode.parentNode.style.display = "";
        pw.parentNode.parentNode.style.display = "";
        interval.parentNode.parentNode.style.display = "";
    }
}

function toggleMailInterval(fldName, sectionDayOfWeek, sectionDayOfMonth) {
    var drop = document.getElementsByName(fldName);
    var divWeek = document.getElementById(sectionDayOfWeek);
    var divMonth = document.getElementById(sectionDayOfMonth);
    switch (drop[0].selectedIndex) {
        case 0:
            divWeek.style.visibility = divMonth.style.visibility = 'collapse';
            break;
        case 1:
            divWeek.style.visibility = 'visible';
            divMonth.style.visibility = 'collapse';
            break;
        case 2:
            divWeek.style.visibility = 'collapse';
            divMonth.style.visibility = 'visible';
            break;
    }
}

function changeBaseFilter(selectName, linkName, tab, mode) {
    var elem = document.getElementsByName(selectName + "[]")[0];
    var filterId = elem.options[elem.selectedIndex].value;
    var link = document.getElementsByName(linkName)[0];
    link.href = "";
    link.onclick = function() {
        self.open("config_reporting.php?tab=" + tab + "&mode=" + mode + "&filter_id=" + filterId + "&showfilter=1",'','width=800, height=800, resizable=yes, scrollbars=yes'); 
        return false;
    };
}

function changePbx(pbxName, objectName, url, valAutoFocus, valDelay) {
    var pbx = document.getElementsByName(pbxName + "[]")[0];
    url = url + "&pbx=" + encodeURIComponent(pbx.options[pbx.selectedIndex].value);
    $( "#" + objectName ).autocomplete({ source: url, autoFocus: valAutoFocus, delay: valDelay, minLength: 1 });
}

function changeDirectDownload(dlName, sortByName, sortOrderName) {
    var dl = document.getElementsByName(dlName + "[]")[0];
    var sortBy = document.getElementsByName(sortByName + "[]")[0];
    var sortOrder = document.getElementsByName(sortOrderName + "[]")[0];
    if(dl.options[dl.selectedIndex].value == "") {
        sortBy.parentNode.parentNode.style.visibility = 'collapse';
        sortOrder.parentNode.parentNode.style.visibility = 'collapse';
    }
    else {
        sortBy.parentNode.parentNode.style.visibility = 'visible';
        sortOrder.parentNode.parentNode.style.visibility = 'visible';
    }
}